<?php

namespace Treewec\Admin;

/**
 * Test class for FileDeleteForm.
 * Generated by PHPUnit on 2012-06-25 at 13:15:58.
 * @group admin_fileform
 */
class FileDeleteFormTest extends \PHPUnit_Framework_TestCase {

    private $formObject;

    protected function setUp() {
        $_POST['submit'] = 'submit';
    }

    public function testSuccessFileDelete() {
        $filenames = array('test-delete', 'žeš-delete');
        foreach ($filenames as $name) {
            $path = $this->getPath($name, true);
            file_put_contents($path, '');
            $this->assertDelete($path);
        }
    }

    public function testSuccessFolderDelete() {
        $filenames = array('test-delete', 'žeš-delete');
        foreach ($filenames as $name) {
            $path = $this->getPath($name, false);
            mkdir($path);
            $this->assertDelete($path);
        }
    }

    public function testSuccessDeleteFolderWithIndex() {
        $path = $this->getPath('test-delete', false);
        mkdir($path);
        file_put_contents($path . '/' . TREEWEC_NAME_OF_INDEX_FILE . TREEWEC_DEFAULT_FILE_EXTENSION, 'default content');
        $this->assertDelete($path);
    }

    public function testSuccessDeleteFolderWithIndexAndDirorder() {
        $path = $this->getPath('test-delete', false);
        mkdir($path);
        file_put_contents($path . '/' . TREEWEC_NAME_OF_INDEX_FILE . TREEWEC_DEFAULT_FILE_EXTENSION, 'default content');
        file_put_contents($path . '/dir.order', 'default content');
        $this->assertDelete($path);
    }

    public function testNonEmptyDir() {
        $this->setFormAndProcess(TEMP_FILEDIR);
        parent::assertFalse($this->formObject->isValid());
    }

    public function testMainPublicationFolder() {
        $this->setFormAndProcess(TREEWEC_VIEW_DIR);
        parent::assertFalse($this->formObject->isValid());
    }

    public function testInvalidPath() {
        $this->setFormAndProcess(new \Exception());
        parent::assertFalse($this->formObject->isValid());
    }

    private function assertDelete($filePath) {
        parent::assertTrue(file_exists($filePath));
        $this->setFormAndProcess($filePath);
        parent::assertTrue($this->formObject->isValid());
        parent::assertFalse(file_exists($filePath));
    }

    private function setFormAndProcess($filePath) {
        $this->formObject = new FileDeleteForm('submit', true);
        $this->formObject->setSuccessAction(FormSuccessAction::NOTHING);
        $this->formObject->setFilePath($filePath);
        $this->formObject->process();
    }

    private function getPath($name, $isFile) {
        $extension = $isFile ? '.php' : '';
        return TEMP_FILEDIR . \Treewec\FileSystem\Path::toFileSystem($name) . $extension;
    }

}

?>